/*			PCSocks.s V 2.0
		(c) 2003 by Dimitri Junker
			Adenauerallee 30
			52066 Aachen

		Dieses File ist Teil des In2Cat-Projektes und steht unter der
		In2Cat Public License. Dementspechend ist es Freeware und darf
		entsprechend der o.g. Liscense weitergegeben und verndert werden.
		Eine Kopie der In2Cat Public License liegt diesem Paket bei
		Diese Copyright Meldung darf nur vom Copyright Inhaber gendert werden.
		Dieses File entstand auf Basis ses Beispielfiles von ASH.
*/

GLOBL win_sock_init,win_socket,win_connect,win_send,win_recvfrom
GLOBL win_sclose,win_shutdown,win_gethostname,win_connectC,win_inet_addr
GLOBL dll_version,win_hasConn2In,win_selConn,win_dial,win_hangUp
GLOBL dll_versionAbwC,winT_selConn,winT_dial,init_clock,win_clock
GLOBL win_gethostIP,win_lstErr,win_create,win_gethostbyname, win_Receive
GLOBL win_getHandle,win_select, win_sendTHS
GLOBL win_done, win_recvfromTHS, win_connectCTHS, win_ReceiveTHS, win_connectTHS
*                                                 FS  15.08.96
*
*   =============================================================
*   Beispiel fr den Aufruf der MPS-Funktionen von Motorola aus
*   =============================================================
*
* Quelle Windows-seitig:
* ----------------------
* mps_base.cpp, mps_demo.cpp
*
mps_code .equ  $4fbf                   * !! NICHT NDERN !!
DLL_ID   .equ  $44594a01               * hier eigene DLL_ID eintragen


* -------------------------------------------------------------------- */
*		Funktionen														*/
* -------------------------------------------------------------------- */
.text
;void *win_sock_init(void *buf);

MODULE win_sock_init
*     ===========================      * Funktion 0 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     0                       * Funktionsnummer (hier 0)
*     ===========================
	rts
ENDMOD

;extern void *win_socket(long type);
MODULE win_socket
*     ===========================      * Funktion 1 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     1                       * Funktionsnummer (hier 1)
*     ===========================
	rts
ENDMOD

;int win_connect(void * s, const void *addr, int addrlen);
MODULE win_connect
*     ===========================    * Funktion 2 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     2                       * Funktionsnummer (hier 2)
*     ===========================
	rts
ENDMOD

;int win_send(CSocket *sock, const void *msg, int len, int flags);
MODULE win_send
*     ===========================    * Funktion 3 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     3                       * Funktionsnummer (hier 3)
*     ===========================
	rts
ENDMOD

; long win_recvfrom(void *sock, void *buf, long len, int flags, void *from, long *fromlen, long timeOut);
MODULE win_recvfrom

	movem.l a2/a3,-(sp)					*Alle Parameter in Register
	movea.l 12(sp),a2;
	movea.l 16(sp),a3;
	
*     ===========================    * Funktion 4 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     4                       * Funktionsnummer (hier 4)
*     ===========================
	movem.l (sp)+,a2/a3
	rts
ENDMOD

;int win_sclose(void *sock);
MODULE win_sclose
*     ===========================    * Funktion 5 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     5                       * Funktionsnummer (hier 5)
*     ===========================
	rts
ENDMOD

;int win_shutdown(void *sock, int how);
MODULE win_shutdown
*     ===========================    * Funktion 6 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     6                       * Funktionsnummer (hier 6)
*     ===========================
	rts
ENDMOD

;int win_gethostname(char *name, int len);
MODULE win_gethostname
*     ===========================    * Funktion 7 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     7                       * Funktionsnummer (hier 7)
*     ===========================
	rts
ENDMOD

;int win_connectC(void *sock, char *url,int port);
MODULE win_connectC
*     ===========================    * Funktion 8 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     8                       * Funktionsnummer (hier 8)
*     ===========================
	rts
ENDMOD

; long win_inet_addr(const char *cpp);
MODULE win_inet_addr
*     ===========================    * Funktion 9 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     9                       * Funktionsnummer (hier 9)
*     ===========================
	rts
ENDMOD

; int dll_version(void);
MODULE dll_version
*     ===========================    * Funktion 10 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     10                      * Funktionsnummer (hier 10)
*     ===========================
	rts
ENDMOD

; long win_hasConn2In();
MODULE win_hasConn2In
*     ===========================    * Funktion 11 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     11                      * Funktionsnummer (hier 11)
*     ===========================
	rts
ENDMOD

; long win_selConn(char *conn,size_t len,BOOL showStar);
MODULE win_selConn
*     ===========================    * Funktion 12 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     12                      * Funktionsnummer (hier 12)
*     ===========================
	rts
ENDMOD

; long win_dial(char *conn,char *uName,char *uPassw);
MODULE win_dial

	movem.l a2,-(sp)					*Alle Parameter in Register
	movea.l 8(sp),a2;
	
*     ===========================    * Funktion 13 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     13                      * Funktionsnummer (hier 13)
*     ===========================
	movem.l (sp)+,a2
	rts
ENDMOD

; BOOL win_hangUp(char *name,size_t len);
MODULE win_hangUp
*     ===========================    * Funktion 14 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     14                      * Funktionsnummer (hier 14)
*     ===========================
	rts
ENDMOD

; int dll_versionAbwC(void);
MODULE dll_versionAbwC
*     ===========================    * Funktion 15 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     15                      * Funktionsnummer (hier 15)
*     ===========================
	rts
ENDMOD

; void winT_selConn(char *conn,size_t len,long *ret,BOOL showStar);
MODULE winT_selConn
*     ===========================    * Funktion 16 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     16                      * Funktionsnummer (hier 16)
*     ===========================
	rts
ENDMOD
;long winT_dial(char *conn,char *uName,char *uPassw);
MODULE winT_dial
	movem.l a2,-(sp)					*Alle Parameter in Register
	movea.l 8(sp),a2;
	
*     ===========================    * Funktion 17 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     17                      * Funktionsnummer (hier 17)
*     ===========================
	movem.l (sp)+,a2
	rts
ENDMOD
; fr Multithreadding Tests
MODULE init_clock
*     ===========================    * Funktion 18 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     18                      * Funktionsnummer (hier 18)
*     ===========================
	rts
ENDMOD
;clock_t win_clock(void)
MODULE win_clock
*     ===========================    * Funktion 19 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     19                      * Funktionsnummer (hier 19)
*     ===========================
	rts
ENDMOD


;unsigned long win_gethostIP(void);
MODULE win_gethostIP
*     ===========================    * Funktion 20 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     20                       * Funktionsnummer (hier 20)
*     ===========================
	rts
ENDMOD
;unsigned long win_lstErr(void* sock);
MODULE win_lstErr
*     ===========================    * Funktion 21 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     21                       * Funktionsnummer (hier 21)
*     ===========================
	rts
ENDMOD

;BOOL win_create( void * sock,long type);
MODULE win_create
*     ===========================    * Funktion 22 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     22                       * Funktionsnummer (hier 22)
*     ===========================
	rts
ENDMOD

;long win_gethostbyname(char *name);
MODULE win_gethostbyname
*     ===========================    * Funktion 23 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     23                       * Funktionsnummer (hier 23)
*     ===========================
	rts
ENDMOD

;long int win_Receive(void* sock, void* lpBuf, long int nBufLen, long int nFlags );
MODULE win_Receive
*     ===========================    * Funktion 24 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     24                      * Funktionsnummer (hier 24)
*     ===========================
	rts
ENDMOD

;unsigned long win_getHandle(void *sock);
MODULE win_getHandle
*     ===========================    * Funktion 25 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     25                      * Funktionsnummer (hier 25)
*     ===========================
	rts
ENDMOD

;long int win_select(void* sock,fd_set *readfds,fd_set *writefds,fd_set *exceptfds, timeval *timeout);
MODULE win_select

	movem.l a2-a4,-(sp)					*Alle Parameter in Register
	movea.l 16(sp),a2
	movea.l 20(sp),a3
	movea.l 24(sp),a4
*     ===========================    * Funktion 26 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     26                      * Funktionsnummer (hier 26)
*     ===========================
	movem.l (sp)+,a2-a4
	rts
ENDMOD

;BOOL win_sendTHS(void *DiaSt, const void *msg, int len, int flags);
MODULE win_sendTHS
*     ===========================    * Funktion 27 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     27                      * Funktionsnummer (hier 27)
*     ===========================
	rts
ENDMOD

;bool win_done(void *DiaSt, long *ret);
MODULE win_done
*     ===========================    * Funktion 28 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     28                      * Funktionsnummer (hier 28)
*     ===========================
	rts
ENDMOD

; BOOL win_recvfromTHS(void *DiaSt, void *buf, long len, long flags, void *from, long *fromlen, long timeOut);
MODULE win_recvfromTHS

	movem.l a2/a3,-(sp)					*Alle Parameter in Register
	movea.l 12(sp),a2;
	movea.l 16(sp),a3;
	
*     ===========================    * Funktion 29 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     29                       * Funktionsnummer (hier 29)
*     ===========================
	movem.l (sp)+,a2/a3
	rts
ENDMOD

;int win_connectCTHS(void *DiaSt, char *url, int port);
MODULE win_connectCTHS
*     ===========================    * Funktion 30 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     30                      * Funktionsnummer (hier 30)
*     ===========================
	rts
ENDMOD

;long int win_ReceiveTHS(void* sock, void* lpBuf, long int nBufLen, long int nFlags );
MODULE win_ReceiveTHS
*     ===========================    * Funktion 31 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     31                      * Funktionsnummer (hier 31)
*     ===========================
	rts
ENDMOD

;int win_connectTHS(void * DiaSt, const void *addr, long addrlen);
MODULE win_connectTHS
*     ===========================    * Funktion 32 aufrufen:
	dc.w     mps_code                * = $4fbf 
	dc.l     DLL_ID                  * = eigene DLL_ID
	dc.w     32                      * Funktionsnummer (hier 32)
*     ===========================
	rts
ENDMOD